{{
  ----------------------------------------------------------------
  Propeller Based Webserver (Webserver for HIVE-Administra Hive R13)

  Based on webserver-code from Parallax-Forum User "Patrik1ab"

  changes for WebProp from GKR aka TuxFan

  Version : 0.1	 alpha-Stadium / Experimentalphase / Benutzung auf eigene Gefahr 
  ----------------------------------------------------------------
  The hardware called "WebProp", based on the "MonoProp" hardware
  http://hive-project.de/board/viewtopic.php?f=24&t=330&sid=0a8b6d707bdcbcaaa9b30fc27328cba4
}}

CON

  _clkmode   = xtal1+pll16x
  _xinfreq   = 5_000_000

' Pin configuration for WebHiveAdministra
' Ethernet pins                                 HIVE    WebProp
  NIC_CS      = 14      ' Chip select           14      0
  NIC_SCK     = 15      ' Clock signal          15      1
  NIC_SI      = 16      ' Slave in              16      2
  NIC_SO      = 17      ' Slave out             17      3
' Header-pins control the Webserver             HIVE    WebProp
  ONOFF       = 19      ' Switch un-/mount SD   19      4
  Lfehler     = 20      ' LED sdfat Fehler      20      5
  Lunmount    = 21      ' LED sdfat unmount     21      6
  Lmount      = 22      ' LED sdfat mount       22      7
' SD-card pins                                  HIVE    WebProp
  SD_DO       = 10      ' Data (Slave) out      10      8
  SD_SCK      = 11      ' Clock signal          11      9
  SD_DI       = 12      ' Data (Slave) in       12      10
  SD_CS       = 13      ' Chip select           13      11
{
' Header-pins only used with SPI-Interface from RF12B-Radiomodul
  P12	        = 12      ' not used with HIVE comment out
  P13         = 13      ' "
  P14	        = 14      ' "
  P15         = 15      ' "
}
{ VGA-, Mouse- and Keyboardpins are not used with WebProp-hardware or Hive-Administra
' VGA-pins
  V           = 16      ' Vertical
  H           = 17      ' Horizontal
  B1          = 18      ' Blue 1
  B2          = 19      ' Blue 2
  G1          = 20      ' Green 1
  G2          = 21      ' Green 2
  R1          = 22      ' Red 1
  R2          = 23      ' Red 2
' Mouse-pins
  MDAT        = 24
  MCLK        = 25
' Keyboard-pins  
  KDAT        = 26
  KCLK        = 27
}
' I2C-bus-pins and Lock-variable
  SCL         = 28            ' -1 if unused.
  SDA         = 29            ' -1 if unused.
  LCK         = -1            ' -1 if unused.
' TX/RX pin defines (standard Prop pins)
  RXD         = 30
  TXD         = 31

  BufferSize  = 1024
  rxlen       = 128



OBJ

  web     : "api_telnet_serial"
  str     : "util_strings"
  ste     : "ASCII0_STREngine"
  sdfat   : "DS1307_SD-MMC_FATEngine"
  tim     : "Timing.spin"


VAR

  byte bSend
  long webStack[64]
  long size
  byte position 
  byte sendwebBuffer[BufferSize]
  byte receivewebBuffer[rxlen]
  byte temp
  byte fname[13]
  byte fending[4]
  long type
  byte reqstr[32]               ' request string 
  long args
  long rdlist
  long hour,minute,second,dayM,month,year
  long setSeconds,setMinutes,setHour,setDay,setDate,setMonth,setYear

DAT
'Change xxx to your LAN-adresses
  mac_addr        byte    $10, $00, $00, $00, $00, $01
  ip_addr         byte    192, 168, xxx, xxx                   ' device's ip address (CHANGE THIS)
  ip_subnet       byte    255, 255, 255, 0                     ' network subnet
  ip_gateway      byte    192, 168, xxx, xxx                   ' network gateway (router)
  ip_dns          byte    192, 168, xxx, xxx                   ' network dns
  dhcp_or_static  byte    0

PUB main
' Initialize switch and leds
  dira[ONOFF]~
  dira[Lmount]~~
  dira[Lunmount]~~
  dira[Lfehler]~~
' Initialize listing of root directory
  rdlist := 1     ' 0 no root directory listing
                  ' 1 root directory listing available
' Start Ethernet
  web.start(NIC_CS,NIC_SCK,NIC_SI,NIC_SO,-1,-1,@mac_addr,@ip_addr)
' Initialize SD-Card
  if initSD <> -1
' If SD-Card ist mounted start the webserver
    cognew(webServer, @webStack)
    outa[Lmount]~~
    outa[Lunmount]~
    outa[Lfehler]~
    repeat
      repeat until ina[ONOFF] == 0
      tim.pause1s(2)
      sdfat.unmountPartition
      outa[Lunmount]~~
      outa[Lmount]~
      repeat until ina[ONOFF] == 0
      tim.pause1s(2)
      sdfat.mountPartition(0)
      outa[Lunmount]~
      outa[Lmount]~~
  outa[Lfehler]~~
  tim.pause1s(2)
  sdfat.unmountPartition


PRI webServer
  ' web server (runs in a seperate cog)
  \web.listen(80, @receivewebBuffer, rxlen, @sendwebBuffer, BufferSize)
  repeat
    if \web.isConnected
      if \webServerThread == 0
        \web.txflush
      \web.close
    \web.relisten 

DAT

http200       byte      "HTTP/1.0 200 OK",13,10,0
http403       byte      "HTTP/1.0 403 Forbidden",13,10,13,10,0
http404       byte      "HTTP/1.0 404 Not Found",13,10,13,10,0
http501       byte      "HTTP/1.0 501 Not Implemented",13,10,13,10,0
http503       byte      "HTTP/1.0 503 Service Unavailable",13,10,13,10,0
filelist      byte      "<html>Liste der Dateien auf dem Webserver:<br>------------------------------------<br><br>",0
crlf          byte      13,10,0

PRI webServerThread | ptr, row, c, h, j, n, m, i, buffer, name ', type
  ' handles a single client connection

  m:=0
  if _webReadLine == 0                         ' read the first header, quit if it is empty
    return 0

  bytemove(@reqstr, @receivewebBuffer, 32)     ' copy the header to a temporary request string for later processing

  ' obtain get arguments
  if (i := str.indexOf(@reqstr, string(".cgi?"))) <> -1 ' was the request for a *.cgi script with arguments?
    args := @reqstr[i + 5]                              ' extract the argument
    if (j := str.indexOf(args, string("="))) <> -1      ' find the end of the argument
      byte[args][j] := 0                                ' string termination

  ' read the rest of the headers

  repeat until _webReadLine == 0              ' read the rest of the headers, throwing them away

  if str.indexOf(@reqstr, string("GET")) <> -1     
  elseif str.indexOf(@reqstr, string("POST")) <> -1  
  elseif str.indexOf(@reqstr, string("HEAD")) <> -1

    m:=1
  else
    web.str(@http501)
    return -1                   ' unrecognized method / not implemented; send 501 error message

  j:=0
  h:=0
  i:=0
  temp:=0

  position:=str.indexOf(@reqstr, string(" /"))+2
  repeat until j==12
    fname[j]:=reqstr[position]' reading the filename (it has to be in the 8.3 format or shorter)
    if fname[j]==32
      temp:=j
      fname[j]:=0             ' let the filename be a zero terminated string (not necessary for fsrw, but avoiding problems when using strcomp)
      quit
    position++
    j++ 

' Service to display date and time from server RTC
  str.ToLower(@fname)
  if strcomp(@fname,string("clock"))
    DateTime
    return 0
' Service to set the RTC
  str.ToLower(@fname)
  if strcomp(@fname,string("setclock"))
    SetRTC(setSeconds,setMinutes,setHour,setDay,setDate,setMonth,setYear)
    return 0


  if fname[0]==32              ' if there is no filename in the request, send a list of files which are stored on the sd card
    if rdlist == 0             ' if rdlist = 1 a filelist is allowed
      web.str(@http200)
      web.str(@crlf)
      web.str(@filelist)
      repeat while(buffer := sdfat.listEntries("r"))
        temp++                                ' !!! Exception: I'm using the same variable for two different purposes (file length [see above] <-> number of files [here]) !!!
        web.str(buffer)
        web.str(string("<br>"))
      web.str(string("<br>"))
      web.str(string("Dateien insgesamt: "))
      web.dec(temp)
      web.str(string("</html>"))
      return 0
    else                                    ' if rdlist = 0  a filelist is not allowed
      web.str(@http403)
      return 0


  if temp==0                                ' get the file extension...
    fending[0]:=fname[9]                    ' if the filename matches the 8.3 format, it's the last three entries of fname
    fending[1]:=fname[10]
    fending[2]:=fname[11]
  else 
    fending[0]:=fname[temp-3]               ' otherwise temp marks the space after the filename
    fending[1]:=fname[temp-2]
    fending[2]:=fname[temp-1]
  fending[3]:=0                             ' zero terminated string in order to use strcomp
  
  if strcomp(@fending, string("htm"))       ' ... and decide what MIME type it is
    type := string("text/html")             ' of course there are a lot more, but these
  elseif strcomp(@fending, string("avi"))   ' I think are the most common ones
    type := string("video/x-msvideo")       ' or at least the ones I needed ;-)
  elseif strcomp(@fending, string("mpg"))
    type := string("video/mpeg")
  elseif strcomp(@fending, string("bmp"))
    type := string("image/bmp")
  elseif strcomp(@fending, string("jpg"))
    type := string("image/jpeg")
  elseif strcomp(@fending, string("gif"))
    type := string("image/gif")
  elseif strcomp(@fending, string("pdf"))
    type := string("application/pdf")
  elseif strcomp(@fending, string("zip"))
    type := string("application/zip")
  elseif strcomp(@fending, string("wav"))
    type := string("audio/x-wav")
  elseif strcomp(@fending, string("mp3"))
    type := string("audio/mpeg")
  elseif strcomp(@fending, string("m4a"))
    type := string("audio/x-m4a")
  else
    type := string(" ")


  name := sdfat.openFile(@fname,"R")    ' Try to open the requested file

  ste.StringToLowerCase(name)
  ste.TrimString(name)

  ifnot strcomp(@fname, name)
    web.str(@http404)                   ' if it is not found on the sd card send back the 404 error message
  else

'If the following header part is used, nothing is displayed in the browser
    size := sdfat.fileSize
'    web.str(@http200)                   ' file has been found and will be transmitted,
'    web.str(string("Server: WebProp"))  ' but first we are going to send the header
'    web.str(@crlf)                      ' which includes some information about the server and file
'    web.str(string("Content-Length: "))
'    web.dec(size)
'    web.str(@crlf)
'    web.str(string("Content-Type: "))
'    web.str(type)
'    web.str(@crlf)
'    web.str(string("Connection: close"))
'    web.str(@crlf)
'    web.str(@crlf)                      ' This is the end of the Header
    if m==1
      return 0
    else
      repeat
        h:=sdfat.readData(@sendwebBuffer,BufferSize)  ' now we are reading the first BufferSize (4096 default) bytes
        if h=<0                                   ' if there are no bytes to read then exit the loop                          
          quit                                                             
        else                                                               
          if h<BufferSize                         ' if the bytes read are less than BufferSize...
            repeat n from h to (BufferSize-1)     ' ...then empty the rest of the webBuffer by overwriting it with " " ...
              sendwebBuffer[n]:=32
          sendwebBuffer[BufferSize]:=0            ' last element of the webBuffer has to be zero
          web.txdata(@sendwebBuffer,h)            ' send the h bytes read

  return 0


PRI _webReadLine | i, ch
  repeat i from 0 to 126
    ch := web.rxtime(500)
    if ch == 13
      ch := web.rxtime(500)
    if ch == -1 or ch == 10
      quit
    receivewebBuffer[i] := ch
  receivewebBuffer[i] := 0
  return i

PRI initSD
' FATEngineStart(DOPin,CLKPin,DIPin,CSPin,WPPin,CDPin,RTCDATPin,RTCCLKPin,I2CLock) '' 15 Stack Longs
  ifnot sdfat.FATEngineStart(SD_DO,SD_SCK,SD_DI,SD_CS,-1,-1,SDA,SCL,-1)
    outa[Lfehler]~~
  if result := sdfat.mountPartition(0)
    outa[Lfehler]~~
    outa[Lunmount]~~
  if \sdfat.mountPartition(0) <> 0
    outa[Lfehler]~~
    outa[Lunmount]~~
    sdfat.unmountPartition
    return -1


PRI DateTime
' Function to display date and time
  sdfat.ReadTime
  sdfat.ReadTime
  year    :=sdfat.Year
  month   :=sdfat.Month
  dayM    :=sdfat.DayM
  hour    :=sdfat.Hour
  minute  :=sdfat.Minute
  second  :=sdfat.Second
  web.str(@http200)
  web.str(@crlf)
  web.str(string("<html>Datum :<br>"))
  web.dec(dayM)
  web.str(string("."))
  web.dec(month)
  web.str(string("."))
  web.dec(year)
  web.str(string("<br>Uhrzeit :<br>"))
  web.dec(hour)
  web.str(string(":"))
  if minute < 10
    web.str(string(" "))
  web.dec(minute)
  web.str(string(":"))
  if second < 10
    web.str(string(" "))
  web.dec(second)
  web.str(string("<br></html>"))

PRI SetRTC(setS,setM,setH,setDa,setDe,setMo,setYe)
  web.str(string("<html>In Vorbereitung : RTC einstellen<br></html>"))

DAT
{{ LICENSE SECTION

                          TERMS OF USE: MIT License

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation  the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
}}





